﻿#include <cstdio>
#include <cmath>
using namespace std;

typedef double (*YourFunction)(double);	// Определяем указатель на функцию от одной переменной типа double, возвращающей значение типа double

double simpleIter(const YourFunction f, double a, double b, double eps, double m, double M) // Метод простой итерации для функции f на интервале (a, b) с точностью eps и числами m и M для подготовки
{
   // т.к. в С++ нет вложенных функций, то будем писать итерационную функцию в явном виде		
				// Алгоритм
   double alpha = 2/(M + m);
   double q = (M - m)/(M + m);
   double x0 = (a + b)/2; // вообще говоря, в качестве начального приближения можно брать любое число из (a, b)
   double x1 = x0 - alpha * (*f)(x0); // первая итерация
   while (q/(1 - q) * abs(x1 - x0) >= eps)
   {
      x0 = x1;
      x1 = x0 - alpha * (*f)(x0);
   }
   return x1;
}

double MyFunction(double x)
{
   return x/2 - cos(2 * x); // Функция из примера
}

int main()
{
   printf("%.6f\n", simpleIter(MyFunction, 0.0, 3.0, 0.001, 0.5, 3.0));	// Выводим корень c 6 цифрами после точки в консоль
   return 0;
}
